.PHONY: leeroy jenkins leeroy-all opentk-jcw
.PHONY: create-vsix

#
# framework-assemblies lives in bin/Build$(CONFIGURATION)/rules.mk generated by `make prepare`
#
# It has to be invoked with $(MAKE) because otherwise rules.mk would not be included and we'd
# get a build failure.
#
# The other targets depended upon by leeroy also require rules.mk to be present and thus they
# are invoked in the same way framework-assemblies is
#
# Local `make jenkins` invocations should build everything by default. We need to ensure `-a` is passed to xaprepare when no CI flags are set.
#
jenkins:
ifeq ($(PREPARE_CI_PR)$(PREPARE_CI),00)
	$(MAKE) PREPARE_ARGS=-a prepare
else
	$(MAKE) prepare
endif
	$(MAKE) leeroy $(ZIP_OUTPUT)
ifeq ($(XA_INVERTED_COMMERCIAL_BUILD),true)
	$(MAKE) commercial
endif

leeroy: leeroy-all framework-assemblies opentk-jcw

leeroy-all:
	$(call MSBUILD_BINLOG,leeroy-all,$(_SLN_BUILD)) $(SOLUTION) /p:Configuration=$(CONFIGURATION) $(_MSBUILD_ARGS)

opentk-jcw:
	$(foreach api_level, $(API_LEVELS), \
		touch bin/$(CONFIGURATION)/lib/xamarin.android/xbuild-frameworks/MonoAndroid/*/OpenTK-1.0.dll; \
		$(call MSBUILD_BINLOG,OpenTK-JCW,$(_SLN_BUILD)) $(MSBUILD_FLAGS) src/OpenTK-1.0/OpenTK.csproj \
			/t:GenerateJavaCallableWrappers /p:Configuration=$(CONFIGURATION) $(_MSBUILD_ARGS) \
			/p:AndroidApiLevel=$(api_level) /p:AndroidPlatformId=$(word $(api_level), $(ALL_PLATFORM_IDS)) /p:AndroidFrameworkVersion=$(word $(api_level), $(ALL_FRAMEWORKS)) || exit 1; )
